<template>
  <v-container fluid>
     <v-data-table :headers="headers" :items="users" hide-actions  class="elevation-1" :search="search">
      <template slot="items" slot-scope="props">
        <td class="text-xs-left">{{ props.item.first_name }}</td>
        <td class="text-xs-left">{{ props.item.last_name }}</td>
        <td class="justify-center layout px-0">
          <v-btn icon class="mx-0" @click="$refs.editDialog.open(props.item)">
            <v-icon color="teal">edit</v-icon>
          </v-btn>
          <v-btn icon class="mx-0" @click="delUser(props.item)">
            <v-icon color="pink">delete</v-icon>
          </v-btn>
        </td>
      </template>
    </v-data-table>

    <v-btn fixed dark fab bottom right color="pink" @click="$refs.addDialog.open()">
      <v-icon>add</v-icon>
    </v-btn>
    <FormDialog ref="addDialog" name="Add User" :fields="fields" @submit="addUser"></FormDialog>
    <FormDialog ref="editDialog" name="Edit User" :fields="fields" @submit="updUser"></FormDialog>
  </v-container>
</template>

<script>
import { FormDialog } from '../components'

export default {
  components: {FormDialog},
  name: 'Users',
  data: () => ({
    dialog: false,
    headers: [
      {value: 'first_name', text: 'First Name'},
      {value: 'last_name', text: 'Last Name'}
    ],
    users: [],
    fields: [
      {type: 'text', name: 'first_name', label: 'First name', required: true, rules: [ v => !!v || 'Name is required', v => (v && v.length <= 16) || 'Name must be less than 16 characters' ]},
      {type: 'text', name: 'last_name', label: 'Last name', required: true, rules: [ v => !!v || 'Name is required', v => (v && v.length <= 16) || 'Name must be less than 16 characters' ]},
      {type: 'text', name: 'email', label: 'Email', required: true, rules: [ v => !!v || 'E-mail is required', v => /^\w+([.-]?\w+)*@\w+([.-]?\w+)*(\.\w{2,3})+$/.test(v) || 'E-mail must be valid' ]},
      {type: 'password', name: 'password', label: 'Password', required: false },
      {type: 'select', name: 'role_id', label: 'Role', required: true, items: []}
    ]
  }),
  created () {
    this.init()
  },
  methods: {
    async init () {
      let res = await this.$http.get('/api/users')
      this.users = res.data
      console.log(this.users)
      res = await this.$http.get('/api/roles')
      this.fields[4].items = res.data
    },
    async addUser (params) {
      let res = await this.$http.post('/api/users', params)
      this.users.push(res.data)
    },
    async updUser (params) {
      let res = await this.$http.put('/api/users/' + params.id, params)
      Object.assign(this.users[this.idIndex(params.id)], res.data)
    },
    async delUser (params) {
      let res = await this.$http.delete('/api/users/' + params.id, params)
      this.users.splice(this.idIndex(res.data), 1)
    },
    idIndex (id) {
      return this.users.findIndex(x => x.id === Number(id))
    }
  },
  props: [
    'search'
  ]
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>

</style>
